// sen-speed Demo
// Der Code misst ueber einen Zeitraum (5 Sekunden voreingestellt)
// die Umdrehungen der Encoder-Scheibe, rechnet diese dann auf Umdrehungen
// pro Minute um und gibt diese über die serielle Schittstelle aus.


// Import einer Bibliothek
#include "TimerOne.h"
#define pin 2


// Benoetigte Variablen
int interval, wheel, counter;
unsigned long previousMicros, usInterval, calc;

void setup()
{
  counter = 0;  // counter auf 0 setzen
  interval = 5;  // 5 Sekunden Intervall
  wheel = 20; // Loecher in der Encoder-Scheibe
  
  calc = 60 / interval;  // Intervall auf 1 Minute hoch rechnen
  usInterval = interval * 1000000;  // Intervallzeit fuer den Timer in
                                    // Mikrosekunden umrechnen
  wheel = wheel * 2;  // Anzahl der Loecher in der Encoder-Scheibe mit 2
                      // multiplizieren, da der Interrupt bei jeder
                      // Aenderung des Signals ausgefuehrt wird

  pinMode(pin, INPUT);  // Setzen des analogen Pins als Input
  Timer1.initialize(usInterval);  // Timer initialisieren auf dem Intervall
  attachInterrupt(digitalPinToInterrupt(pin), count, CHANGE);
  // fuehrt count aus, wenn sich das Signal am Pin 2 aendert
  
  Timer1.attachInterrupt(output);  // fuehrt nach Intervall output aus
  Serial.begin(9600);  // starten der seriellen Schnittstelle mit 9600 Baud
}

// Zaehlt Loecher der Encoder-Scheibe (mit Filter)
void count(){
  if (micros() - previousMicros >= 700) {
    counter++;
    previousMicros = micros();
  }
}

// Ausgabe im seriellen Monitor
void output(){
  Timer1.detachInterrupt(); // Unterbricht Timer
  Serial.print("Drehzahl pro Minute: ");
  int speed = ((counter)*calc) / wheel;
  // Berechnung der Umdrehungen pro Minute
  
  Serial.println(speed);
  counter = 0;  // zuruecksetzen des Zaehlers
  Timer1.attachInterrupt(output);  // startet Timer erneut
}

void loop(){
 // keine loop notwendig 
}
